std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >(3)

NAME
std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > -

SYNOPSIS

Inherits std::__allow_copy_cons< bool >.

  Public Types

typedef _Hashtable::key_type key_type
typedef _Hashtable::value_type value_type
typedef _Hashtable::mapped_type mapped_type
typedef _Hashtable::hasher hasher
typedef _Hashtable::key_equal key_equal
typedef _Hashtable::allocator_type allocator_type

typedef allocator_type::pointer pointer
typedef
allocator_type::const_pointer const_pointer"
typedef allocator_type::reference reference
typedef
allocator_type::const_reference const_reference"
typedef _Hashtable::iterator iterator
typedef _Hashtable::const_iterator const_iterator
typedef _Hashtable::local_iterator local_iterator
typedef
_Hashtable::const_local_iterator const_local_iterator"
typedef _Hashtable::size_type size_type
typedef _Hashtable::difference_type difference_type

  Public Member Functions
unordered_map (size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
template<typename _InputIterator > unordered_map (_InputIterator __f, _InputIterator __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
unordered_map (const unordered_map &)=default
unordered_map (unordered_map &&)=default
unordered_map (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
iterator begin () noexcept
local_iterator begin (size_type __n)
size_type bucket (const key_type &__key) const
size_type bucket_count () const noexcept
size_type bucket_size (size_type __n) const
void clear () noexcept
size_type count (const key_type &__x) const
template<typename... _Args> std::pair< iterator, bool > emplace (_Args &&...__args)
template<typename... _Args> iterator emplace_hint (const_iterator __pos, _Args &&...__args)
bool empty () const noexcept
iterator end () noexcept
local_iterator end (size_type __n)
size_type erase (const key_type &__x)
iterator erase (const_iterator __first, const_iterator __last)
allocator_type get_allocator () const noexcept
hasher hash_function () const
template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
void insert (initializer_list< value_type > __l)
key_equal key_eq () const
float load_factor () const noexcept
size_type max_bucket_count () const noexcept
float max_load_factor () const noexcept
void max_load_factor (float __z)
size_type max_size () const noexcept
unordered_map & operator= (const unordered_map &)=default
unordered_map & operator= (unordered_map &&)=default
unordered_map & operator= (initializer_list< value_type > __l)
void rehash (size_type __n)
void reserve (size_type __n)
size_type size () const noexcept
void swap (unordered_map &__x)

const_iterator begin () const noexcept
const_iterator cbegin () const noexcept

const_iterator end () const noexcept
const_iterator cend () const noexcept

std::pair< iterator, bool > insert (const value_type &__x)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> std::pair< iterator, bool > insert (_Pair &&__x)

iterator insert (const_iterator __hint, const value_type &__x)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> iterator insert (const_iterator __hint, _Pair &&__x)

iterator erase (const_iterator __position)
iterator erase (iterator __it)

iterator find (const key_type &__x)
const_iterator find (const key_type &__x) const

std::pair< iterator, iterator > equal_range (const key_type &__x)
std::pair< const_iterator,
const_iterator > equal_range (const key_type &__x) const "

mapped_type & operator[] (const key_type &__k)
mapped_type & operator[] (key_type &&__k)

mapped_type & at (const key_type &__k)
const mapped_type & at (const key_type &__k) const

const_local_iterator begin (size_type __n) const
const_local_iterator cbegin (size_type __n) const

const_local_iterator end (size_type __n) const
const_local_iterator cend (size_type __n) const

  Friends
template<typename _Key1 , typename _Tp1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 > bool operator== (const unordered_map< _Key1, _Tp1, _Hash1, _Pred1, _Alloc1 > &, const unordered_map< _Key1, _Tp1, _Hash1, _Pred1, _Alloc1 > &)

Detailed Description

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >>class std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >
A standard container composed of unique keys (containing at most one of each key value) that associates values of another type with the keys.

Template Parameters:
    _Key Type of key objects.
    _Tp Type of mapped objects.
    _Hash Hashing function object type, defaults to hash<_Value>.
    _Pred Predicate function object type, defaults to equal_to<_Value>.
    _Alloc Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

The resulting value type of the container is std::pair<const _Key, _Tp>.

Base is _Hashtable, dispatched at compile time via template alias __umap_hashtable.

Definition at line 97 of file unordered_map.h.

Member Typedef Documentation

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::allocator_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 111 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 121 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::const_local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 123 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef allocator_type::const_pointer std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 117 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef allocator_type::const_reference std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 119 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::difference_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 125 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::hasher std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 109 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 120 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::key_equal std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 110 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::key_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 106 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 122 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::mapped_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::mapped_type

Public typedefs.

Definition at line 108 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef allocator_type::pointer std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 116 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef allocator_type::reference std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 118 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 124 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> typedef _Hashtable::value_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 107 of file unordered_map.h.

Constructor & Destructor Documentation

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_map (size_type__n = 10, const hasher &__hf = hasher(), const key_equal &__eql = key_equal(), const allocator_type &__a = allocator_type()) [inline], [explicit]

Default constructor creates no elements.

Parameters:
    __n Initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Definition at line 138 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename _InputIterator > std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_map (_InputIterator__f, _InputIterator__l, size_type__n = 0, const hasher &__hf = hasher(), const key_equal &__eql = key_equal(), const allocator_type &__a = allocator_type()) [inline]

Builds an unordered_map from a range.

Parameters:
    __first An input iterator.
    __last An input iterator.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_map consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 159 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_map (const unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > &) [default]

Copy constructor.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_map (unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > &&) [default]

Move constructor.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_map (initializer_list< value_type >__l, size_type__n = 0, const hasher &__hf = hasher(), const key_equal &__eql = key_equal(), const allocator_type &__a = allocator_type()) [inline]

Builds an unordered_map from an initializer_list.

Parameters:
    __l An initializer_list.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_map consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 184 of file unordered_map.h.

Member Function Documentation

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> mapped_type& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::at (const key_type &__k) [inline]

Access to unordered_map data.

Parameters:
    __k The key for which data should be retrieved.

Returns:
    A reference to the data whose key is equal to __k, if such a data is present in the unordered_map.

Exceptions:
    std::out_of_range If no such data is present.

Definition at line 612 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const mapped_type& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::at (const key_type &__k) const [inline]

Access to unordered_map data.

Parameters:
    __k The key for which data should be retrieved.

Returns:
    A reference to the data whose key is equal to __k, if such a data is present in the unordered_map.

Exceptions:
    std::out_of_range If no such data is present.

Definition at line 616 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::begin () [inline], [noexcept]
Returns a read/write iterator that points to the first element in the unordered_map.

Definition at line 248 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_map.

Definition at line 257 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::begin (size_type__n) [inline]

Returns a read/write iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read/write local iterator.

Definition at line 657 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::begin (size_type__n) const [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 668 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::bucket_count () const [inline], [noexcept]

Returns the number of buckets of the unordered_map.

Definition at line 624 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_map.

Definition at line 261 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::cbegin (size_type__n) const [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 672 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_map.

Definition at line 283 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::cend (size_type__n) const [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 698 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::clear () [inline], [noexcept]
Erases all elements in an unordered_map. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 497 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::count (const key_type &__x) const [inline]

Finds the number of elements.

Parameters:
    __x Key to count.

Returns:
    Number of elements with specified key.

This function only makes sense for unordered_multimap; for unordered_map the result will either be 0 (not present) or 1 (present).

Definition at line 560 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename... _Args> std::pair<iterator, bool> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::emplace (_Args &&...__args) [inline]

Attempts to build and insert a std::pair into the unordered_map.

Parameters:
    __args Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to build and insert a (key, value) pair into the unordered_map. An unordered_map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the unordered_map.

Insertion requires amortized constant time.

Definition at line 310 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename... _Args> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::emplace_hint (const_iterator__pos, _Args &&...__args) [inline]

Attempts to build and insert a std::pair into the unordered_map.

Parameters:
    __pos An iterator that serves as a hint as to where the pair should be inserted.
    __args Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns:
    An iterator that points to the element with key of the std::pair built from __args (may or may not be that std::pair).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument emplace() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html for more on hinting.

Insertion requires amortized constant time.

Definition at line 340 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> bool std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::empty () const [inline], [noexcept]

Returns true if the unordered_map is empty.

Definition at line 228 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::end () [inline], [noexcept]
Returns a read/write iterator that points one past the last element in the unordered_map.

Definition at line 270 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::end () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_map.

Definition at line 279 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::end (size_type__n) [inline]

Returns a read/write iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read/write local iterator.

Definition at line 683 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_local_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::end (size_type__n) const [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 694 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::pair<iterator, iterator> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range (const key_type &__x) [inline]

Finds a subsequence matching given key.

Parameters:
    __x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for unordered_multimap.

Definition at line 573 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::pair<const_iterator, const_iterator> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range (const key_type &__x) const [inline]

Finds a subsequence matching given key.

Parameters:
    __x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for unordered_multimap.

Definition at line 577 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::erase (const_iterator__position) [inline]

Erases an element from an unordered_map.

Parameters:
    __position An iterator pointing to the element to be erased.

Returns:
    An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 447 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::erase (iterator__it) [inline]

Erases an element from an unordered_map.

Parameters:
    __position An iterator pointing to the element to be erased.

Returns:
    An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 452 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::erase (const key_type &__x) [inline]

Erases elements according to the provided key.

Parameters:
    __x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all the elements located by the given key from an unordered_map. For an unordered_map the result of this function can only be 0 (not present) or 1 (present). Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 469 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::erase (const_iterator__first, const_iterator__last) [inline]

Erases a [__first,__last) range of elements from an unordered_map.

Parameters:
    __first Iterator pointing to the start of the range to be erased.
    __last Iterator pointing to the end of the range to be erased.

Returns:
    The iterator __last.

This function erases a sequence of elements from an unordered_map. Note that this function only erases the elements, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 487 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::find (const key_type &__x) [inline]

Tries to locate an element in an unordered_map.

Parameters:
    __x Key to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 542 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> const_iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::find (const key_type &__x) const [inline]

Tries to locate an element in an unordered_map.

Parameters:
    __x Key to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 546 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> allocator_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::get_allocator () const [inline], [noexcept]

Returns the allocator object with which the unordered_map was constructed.

Definition at line 221 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> hasher std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::hash_function () const [inline]

Returns the hash functor object with which the unordered_map was constructed.

Definition at line 518 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> std::pair<iterator, bool> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (const value_type &__x) [inline]

Attempts to insert a std::pair into the unordered_map.

Parameters:
    __x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the unordered_map. An unordered_map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the unordered_map.

Insertion requires amortized constant time.

Definition at line 362 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> std::pair<iterator, bool> std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (_Pair &&__x) [inline]

Attempts to insert a std::pair into the unordered_map.

Parameters:
    __x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the unordered_map. An unordered_map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the unordered_map.

Insertion requires amortized constant time.

Definition at line 369 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (const_iterator__hint, const value_type &__x) [inline]

Attempts to insert a std::pair into the unordered_map.

Parameters:
    __hint An iterator that serves as a hint as to where the pair should be inserted.
    __x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    An iterator that points to the element with key of __x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html for more on hinting.

Insertion requires amortized constant time.

Definition at line 396 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type> iterator std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (const_iterator__hint, _Pair &&__x) [inline]

Attempts to insert a std::pair into the unordered_map.

Parameters:
    __hint An iterator that serves as a hint as to where the pair should be inserted.
    __x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    An iterator that points to the element with key of __x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html for more on hinting.

Insertion requires amortized constant time.

Definition at line 403 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> template<typename _InputIterator > void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (_InputIterator__first, _InputIterator__last) [inline]

A template function that attempts to insert a range of elements.

Parameters:
    __first Iterator pointing to the start of the range to be inserted.
    __last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 418 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert (initializer_list< value_type >__l) [inline]

Attempts to insert a list of elements into the unordered_map.

Parameters:
    __l A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 429 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> key_equal std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::key_eq () const [inline]

Returns the key comparison object with which the unordered_map was constructed.

Definition at line 524 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> float std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::load_factor () const [inline], [noexcept]

Returns the average number of elements per bucket.

Definition at line 706 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::max_bucket_count () const [inline], [noexcept]

Returns the maximum number of buckets of the unordered_map.

Definition at line 629 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> float std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::max_load_factor () const [inline], [noexcept]

Returns a positive number that the unordered_map tries to keep the load factor less than or equal to.

Definition at line 712 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::max_load_factor (float__z) [inline]

Change the unordered_map maximum load factor.

Parameters:
    __z The new maximum load factor.

Definition at line 720 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::max_size () const [inline], [noexcept]

Returns the maximum size of the unordered_map.

Definition at line 238 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> unordered_map& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= (const unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > &) [default]

Copy assignment operator.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> unordered_map& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= (unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > &&) [default]

Move assignment operator.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> unordered_map& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= (initializer_list< value_type >__l) [inline]

Unordered_map list assignment operator.

Parameters:
    __l An initializer_list.

This function fills an unordered_map with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_map and that the resulting unordered_map's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 212 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> mapped_type& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator[] (const key_type &__k) [inline]

Subscript ( [] ) access to unordered_map data.

Parameters:
    __k The key for which data should be retrieved.

Returns:
    A reference to the data of the (key,data) pair.

Allows for easy lookup with the subscript ( [] )operator. Returns data associated with the key specified in subscript. If the key does not exist, a pair with that key is created using default values, which is then returned.

Lookup requires constant time.

Definition at line 595 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> mapped_type& std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator[] (key_type &&__k) [inline]

Subscript ( [] ) access to unordered_map data.

Parameters:
    __k The key for which data should be retrieved.

Returns:
    A reference to the data of the (key,data) pair.

Allows for easy lookup with the subscript ( [] )operator. Returns data associated with the key specified in subscript. If the key does not exist, a pair with that key is created using default values, which is then returned.

Lookup requires constant time.

Definition at line 599 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::rehash (size_type__n) [inline]

May rehash the unordered_map.

Parameters:
    __n The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_map maximum load factor.

Definition at line 731 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::reserve (size_type__n) [inline]

Prepare the unordered_map for a specified number of elements.

Parameters:
    __n Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 742 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> size_type std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::size () const [inline], [noexcept]

Returns the size of the unordered_map.

Definition at line 233 of file unordered_map.h.

  template<class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std::equal_to<_Key>, class _Alloc = std::allocator<std::pair<const _Key, _Tp> >> void std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::swap (unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc > &__x) [inline]

Swaps data with another unordered_map.

Parameters:
    __x An unordered_map of the same element and allocator types.

This exchanges the elements between two unordered_map in constant time. Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 510 of file unordered_map.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.